(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@ng-tangram/components/modal'), require('@ng-tangram/components/switch'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/pro/column-controller', ['exports', '@angular/common', '@angular/core', '@ng-tangram/components/modal', '@ng-tangram/components/switch', 'rxjs', 'rxjs/operators'], factory) :
    (global = global || self, factory((global.nt = global.nt || {}, global.nt.pro = global.nt.pro || {}, global.nt.pro.columnController = {}), global.ng.common, global.ng.core, global.nt.components.modal, global.nt.components.switch, global.rxjs, global.rxjs.operators));
}(this, (function (exports, common, core, modal, _switch, rxjs, operators) { 'use strict';

    var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var __param = (this && this.__param) || function (paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    };
    var NtColumnControllerComponent = (function () {
        function NtColumnControllerComponent(data) {
            this.data = data;
            this._destroy = new rxjs.Subject();
            this._displayedColumnChanges = new rxjs.Subject();
            this.displayedColumns = [];
            this.columns = this.data.columns;
            this.columnNames = this.columns.map(function (col) { return col.name; });
            this.displayedColumns = this.data.displayedColumns;
        }
        NtColumnControllerComponent.prototype.ngOnDestroy = function () {
            this._destroy.next();
            this._destroy.complete();
        };
        NtColumnControllerComponent.prototype.displayedColumnChanges = function () {
            return this._displayedColumnChanges
                .asObservable()
                .pipe(operators.takeUntil(this._destroy));
        };
        NtColumnControllerComponent.prototype._onChange = function (change, columnName) {
            var _this = this;
            if (change.checked) {
                this.displayedColumns.push(columnName);
            }
            else {
                var index = this.displayedColumns.indexOf(columnName);
                this.displayedColumns.splice(index, 1);
            }
            var sortedColumns = this.columnNames.filter(function (col) { return _this.displayedColumns.includes(col); });
            this._displayedColumnChanges.next(sortedColumns);
        };
        NtColumnControllerComponent.prototype._trackColumnChecked = function (columnName) {
            return this.displayedColumns.includes(columnName);
        };
        NtColumnControllerComponent.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [modal.NT_MODAL_DATA,] }] }
        ]; };
        NtColumnControllerComponent = __decorate([
            core.Component({
                template: "<nt-modal-header>\n  \u8BBE\u7F6E\n</nt-modal-header>\n<nt-modal-body class=\"padding-0\">\n  <div class=\"setting-list\">\n    <div class=\"setting-list-title\">\n      \u6570\u636E\u5217\u663E\u793A\n    </div>\n    <div class=\"setting-list-menu\">\n      <div class=\"setting-list-item\"\n        [class.disabled]=\"!col.optional\"\n        *ngFor=\"let col of columns\">\n        <a class=\"setting-list-label\">{{ col.label }}</a>\n        <span class=\"setting-list-control\">\n          <nt-switch class=\"large margin-bottom-0\"\n            [checked]=\"_trackColumnChecked(col.name)\"\n            (change)=\"_onChange($event, col.name)\"\n            [disabled]=\"!col.optional\"\n            circle>\n          </nt-switch>\n        </span>\n      </div>\n    </div>\n  </div>\n</nt-modal-body>\n",
                encapsulation: core.ViewEncapsulation.None
            }),
            __param(0, core.Inject(modal.NT_MODAL_DATA))
        ], NtColumnControllerComponent);
        return NtColumnControllerComponent;
    }());

    var __assign = (this && this.__assign) || function () {
        __assign = Object.assign || function(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                    t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    var __decorate$1 = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var MzColumnController = (function () {
        function MzColumnController(modal) {
            this.modal = modal;
            this._defaultModalConfig = {
                width: '460px',
                maxWidth: '90vw',
                maxHeight: '90vh',
                backdropClass: 'light-backdrop'
            };
        }
        MzColumnController.prototype.openAndTrackChanges = function (columns, displayedColumns) {
            var data = { columns: columns, displayedColumns: displayedColumns };
            var modalConfig = __assign(__assign({}, this._defaultModalConfig), { data: data });
            var modalRef = this.modal.open(NtColumnControllerComponent, modalConfig);
            return modalRef.componentInstance.displayedColumnChanges();
        };
        MzColumnController.ctorParameters = function () { return [
            { type: modal.NtModal }
        ]; };
        MzColumnController = __decorate$1([
            core.Injectable()
        ], MzColumnController);
        return MzColumnController;
    }());

    var __decorate$2 = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var NtColumnControlerModule = (function () {
        function NtColumnControlerModule() {
        }
        NtColumnControlerModule = __decorate$2([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    modal.NtModalModule,
                    _switch.NtSwitchModule
                ],
                entryComponents: [NtColumnControllerComponent],
                declarations: [NtColumnControllerComponent],
                providers: [MzColumnController],
            })
        ], NtColumnControlerModule);
        return NtColumnControlerModule;
    }());

    exports.MzColumnController = MzColumnController;
    exports.NtColumnControlerModule = NtColumnControlerModule;
    exports.NtColumnControllerComponent = NtColumnControllerComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=columnController.umd.js.map
