import { CommonModule } from '@angular/common';
import { EventEmitter, Input, Output, Component, TemplateRef, Directive, ViewContainerRef, ChangeDetectorRef, ViewChild, ContentChildren, ChangeDetectionStrategy, ViewEncapsulation, NgModule } from '@angular/core';
import { ActivatedRoute, Router, RouterModule } from '@angular/router';
import { NtLabelModule } from '@ng-tangram/components/label';
import { Subject } from 'rxjs';
import { takeUntil } from 'rxjs/operators';

var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var NtQueryParamComponent = (function () {
    function NtQueryParamComponent() {
        this.remove = new EventEmitter();
    }
    NtQueryParamComponent.prototype.emitRemoveEvent = function () {
        this.remove.emit(this);
    };
    __decorate([
        Input()
    ], NtQueryParamComponent.prototype, "label", void 0);
    __decorate([
        Output()
    ], NtQueryParamComponent.prototype, "remove", void 0);
    NtQueryParamComponent = __decorate([
        Component({
            selector: 'nt-query-param',
            template: "\n    <nt-label class=\"primary\" style=\"margin: .5rem .5rem .5rem 0;\">\n      {{label}}\uFF1A\n      <ng-content></ng-content>\n      <span (click)=\"emitRemoveEvent()\" class=\"fas fa-times\" class=\"clear-icon\"></span>\n    </nt-label>\n  ",
            styles: [".clear-icon { cursor: pointer; margin-left: .5rem; }"]
        })
    ], NtQueryParamComponent);
    return NtQueryParamComponent;
}());

var __decorate$1 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var NtQueryParamDefDirective = (function () {
    function NtQueryParamDefDirective(template) {
        this.template = template;
    }
    NtQueryParamDefDirective.ctorParameters = function () { return [
        { type: TemplateRef }
    ]; };
    __decorate$1([
        Input('ntQueryParamDefKey')
    ], NtQueryParamDefDirective.prototype, "key", void 0);
    NtQueryParamDefDirective = __decorate$1([
        Directive({
            selector: '[ntQueryParamDef]',
        })
    ], NtQueryParamDefDirective);
    return NtQueryParamDefDirective;
}());

var __decorate$2 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var NtQueryParamsOutletDirective = (function () {
    function NtQueryParamsOutletDirective(viewContainerRef) {
        this.viewContainerRef = viewContainerRef;
    }
    NtQueryParamsOutletDirective.ctorParameters = function () { return [
        { type: ViewContainerRef }
    ]; };
    NtQueryParamsOutletDirective = __decorate$2([
        Directive({
            selector: '[ntQueryParamsOutlet]'
        })
    ], NtQueryParamsOutletDirective);
    return NtQueryParamsOutletDirective;
}());

var __decorate$3 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var NtQueryParamsComponent = (function () {
    function NtQueryParamsComponent(viewContainerRef, route, router, _changeDetectorRef) {
        this.viewContainerRef = viewContainerRef;
        this.route = route;
        this.router = router;
        this._changeDetectorRef = _changeDetectorRef;
        this._destroy = new Subject();
        this.hasQuery = false;
    }
    NtQueryParamsComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.route.queryParams.pipe(takeUntil(this._destroy)).subscribe(function (query) {
            if (query) {
                setTimeout(function () {
                    _this._create(query);
                });
            }
        });
    };
    NtQueryParamsComponent.prototype._create = function (query) {
        var _this = this;
        if (this._outlet) {
            this._outlet.viewContainerRef.clear();
            var defs = this.queryParamDefs.toArray();
            var queryKeys_1 = Object.keys(query);
            this.hasQuery = defs.map(function (def) { return def.key; }).some(function (key) { return queryKeys_1.includes(key); });
            defs.forEach(function (def) {
                if (queryKeys_1.includes(def.key)) {
                    var context = { $implicit: query[def.key] };
                    _this._outlet.viewContainerRef.createEmbeddedView(def.template, context);
                }
            });
        }
        this._changeDetectorRef.markForCheck();
    };
    NtQueryParamsComponent.prototype.ngOnDestroy = function () {
        this._destroy.next();
        this._destroy.complete();
    };
    NtQueryParamsComponent.prototype.clearAll = function () {
        this.router.navigate(['./'], { relativeTo: this.route });
    };
    NtQueryParamsComponent.ctorParameters = function () { return [
        { type: ViewContainerRef },
        { type: ActivatedRoute },
        { type: Router },
        { type: ChangeDetectorRef }
    ]; };
    __decorate$3([
        ViewChild(NtQueryParamsOutletDirective, { static: true })
    ], NtQueryParamsComponent.prototype, "_outlet", void 0);
    __decorate$3([
        ContentChildren(NtQueryParamDefDirective, { descendants: true })
    ], NtQueryParamsComponent.prototype, "queryParamDefs", void 0);
    NtQueryParamsComponent = __decorate$3([
        Component({
            selector: 'nt-query-params',
            template: "<div class=\"filtered-wrapper grid-x align-middle\">\n  <!-- <div class=\"filter-text\">\u641C\u7D22\u6761\u4EF6\uFF1A</div> -->\n  <ng-container *ntQueryParamsOutlet></ng-container>\n  <div class=\"clear-all-icon\" (click)=\"clearAll()\">\u6E05\u9664</div>\n</div>",
            changeDetection: ChangeDetectionStrategy.OnPush,
            encapsulation: ViewEncapsulation.None,
            host: {
                'class': 'nt-query-params',
                '[class.hidden]': '!hasQuery'
            },
            styles: ["@-webkit-keyframes query-scale{from{transform:scale(1)}to{transform:scale(0)}}@keyframes query-scale{from{transform:scale(1)}to{transform:scale(0)}}.nt-query-params{transition:.2s}.hidden{height:0!important;min-height:0!important;opacity:0!important;border-bottom:none!important}.hidden .clear-all-icon,.hidden .filter-text{-webkit-animation:.2s query-scale;animation:.2s query-scale}.filter-text{margin-right:.5rem}.clear-all-icon{cursor:pointer;margin-left:.5rem}"]
        })
    ], NtQueryParamsComponent);
    return NtQueryParamsComponent;
}());

var __decorate$4 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var NtQueryParamsModule = (function () {
    function NtQueryParamsModule() {
    }
    NtQueryParamsModule = __decorate$4([
        NgModule({
            imports: [
                CommonModule,
                RouterModule,
                NtLabelModule,
            ],
            declarations: [
                NtQueryParamsComponent,
                NtQueryParamDefDirective,
                NtQueryParamsOutletDirective,
                NtQueryParamComponent
            ],
            exports: [
                NtQueryParamDefDirective,
                NtQueryParamsOutletDirective,
                NtQueryParamsComponent,
                NtQueryParamComponent
            ]
        })
    ], NtQueryParamsModule);
    return NtQueryParamsModule;
}());

export { NtQueryParamComponent, NtQueryParamDefDirective, NtQueryParamsComponent, NtQueryParamsModule, NtQueryParamsOutletDirective as ɵa };
//# sourceMappingURL=queryParams.js.map
